// Manage the display brightness control
#ifndef __AMBIENT_H
#define __AMBIENT_H

typedef struct          // Brightness setting limit
{
    uint16_t adc;           // ADC reading
    uint8_t  timer;         // Timer value for it
} S_LIMIT;

typedef struct          // Both limits
{
    S_LIMIT low;
    S_LIMIT high;
} S_BRIGHT;

typedef enum            // The 2 end-points
{
    LOW,
    HIGH
} E_ENDS;
 
void AmbientInitialise(void);
void AmbientAdjustBrightnessLimit(E_ENDS highpt, int8_t adj);
void AmbientAdjustBrightness(void);
void AmbientDisplaySetting(E_ENDS highpt);

#endif
