// Control-Button Handler
// Manages debounce & auto-repeat of the control buttons
#ifndef __BUTTONS_H
#define __BUTTONS_H

#define BUTTONA 0           // The 3 back-panel buttons
#define BUTTONB 2
#define BUTTONC 1

#define REPTBIT 7           // Flag shows button-press is an auto-repeat

void    ButtonInitialise(void);
uint8_t ButtonGetValue(void);

static inline uint8_t ButtonGetRaw(void){return ((~PINB) >> 3) & 7;}
static inline uint8_t ButtonNoRepeat(uint8_t x){return(x & ~BV(REPTBIT));}

#endif
