/***************************************************************************
*
*   Module      :   GCC type definitions
*   Copyright   :
*   Platform(s) :   AVRMega8
*   Limitations :   none
*   $Workfile: typedefn.h $
*   $Revision: 1.2.1.0 $
*
*---------------------------------------------------------------------------
*
*   Purpose     :   REPLACE with short description of module purpose
*
***************************************************************************/

#ifndef __TYPEDEFN_H
#define __TYPEDEFN_H

/*----- INCLUDES ---------------------------------------------------------*/

#include <stdint.h>             // The proper C99 typedefs
#include <stdbool.h>
#include <avr/io.h>             // IO hardware registers, etc.
#include <util/twi.h>           // I2C bus module
#include <avr/interrupt.h>      // Interrupt support
#include <avr/pgmspace.h>       // Access constants in program area

/*----- DEFINES ----------------------------------------------------------*/

#ifndef BV                      // Bit value (in byte)
    #define BV(X) (1 << (X))
#endif

#ifndef BVL                     // Bit value (in long)
    #define BVL(x) ((uint32_t)1 << (x))
#endif

// Maximum values for one byte integer types
// 'Minimum' is the minimum value that can be
// used in an ABS (Absolute value) function
#define MAX_UINT1   (0xff)
#define MIN_SINT1   ((int8_t)0x81)
#define MAX_SINT1   ((int8_t)0x7f)

// Maximum values for two byte integer types
#define MAX_UINT2   (0xffff)
#define MIN_SINT2   ((int16_t)0x8001)
#define MAX_SINT2   ((int16_t)0x7fff)

#define DIMOF(x)    (sizeof(x) / sizeof(x[0]))

/*----- TYPEDEFS ---------------------------------------------------------*/

typedef uint8_t bcdigs;   // 2 BCD digits

typedef struct          // Complete time, in 24-hour notation
{
    bcdigs minutes;
    bcdigs hours;
} S_TIME;

/*----- EXTERNALS --------------------------------------------------------*/

#if ((defined INCLUDE_EXTERNS)||(!defined __HEADER_C))

#endif /* (defined INCLUDE_EXTERNS)||(!defined __HEADER_C) */

/*----- PROTOTYPES -------------------------------------------------------*/
/*----- INLINE FUNCTIONS -------------------------------------------------*/

#endif /* __HEADER_H */

/*----- END OF FILE ------------------------------------------------------*/
